"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Printer = void 0;

var _prettier = _interopRequireDefault(require("prettier"));

var _prettierPluginSolidity = require("prettier-plugin-solidity");

class Printer {
  constructor(ast) {
    this.ast = ast;
  }

  print() {
    const {
      ast
    } = this; // Yes, yes. This is ridiculous. But go and try and write
    // an AST to code writer and then tell me it's ridiculous.

    let code = _prettier.default.format("<code>", {
      parser(_, parsers, options) {
        // The types on this library don't account for Options.printer,
        // so we'll ask the typechecker to ignore this one, as it errors.
        //
        // @ts-ignore
        options.printer = _prettierPluginSolidity.printers["solidity-ast"];
        return ast;
      }

    }); // Fix some weird cases with the library.


    code = code.replace(/;\)/gm, ")");
    code = code.replace(/;;/gm, ";");
    return code;
  }

}

exports.Printer = Printer;
//# sourceMappingURL=printer.js.map